import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.text.*;
import java.beans.*;

/**
 * This is a simple line that is used to separate the QMonitorPanels.
 *
 * @author tjacopi
 *
 */
public class BorderLine extends JComponent  {

  protected static final int pixelBorder = 3;

  protected int       lineWidth     = 0;
  protected Rectangle bounds = new Rectangle();
  protected Insets    insets = new Insets(0,0,0,0);

    public BorderLine(int lineWidth) {
      this.lineWidth = lineWidth;
      setPreferredSize( new Dimension(2,(2*pixelBorder + lineWidth) ) );
      setBackground(Color.black);
//    setForeground(Color.yellow);
      setForeground(Color.gray);
    }

    public BorderLine() {
      this(2);
    }

    protected void paintComponent(Graphics g) {
      getBounds(bounds);
      getInsets(insets);
      bounds.x = bounds.x + insets.left;
      bounds.y = bounds.y + insets.top;
      bounds.width = bounds.width - insets.right - insets.left;
      bounds.height = bounds.height - insets.top - insets.bottom;

      g.setColor( getBackground() );
      g.fillRect(0, 0, bounds.width, bounds.height);


      g.setColor( getForeground() );
      int yPos = bounds.height/2 - lineWidth/2;
      g.fillRect(0,  yPos, bounds.width, lineWidth);

    }

}