import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.util.*;
import java.sql.*;
import java.beans.*;
import java.text.*;

/**
 * This is the visual lengend on the right hand side of the graph.
 *
 * @author tjacopi
 *
 */
public class LegendPanel extends JPanel implements PropertyChangeListener {

    protected static final String  noActivityValue = "-";

//  protected JLabel          noActivityLB = null;
    protected JLabel[]        labels  = null;
    protected String[]        segmentText = null;
    protected DecimalFormat   decimalFormat = new DecimalFormat("#,###,##0.0");
    protected Color[] segmentColors = null;
    protected SegmentedData data = null;


    public LegendPanel(SegmentedData data, String title, String[] segmentText, Color[] segmentColors) {
      this.data = data;
      this.segmentText = segmentText;
      this.segmentColors = segmentColors;
      setBackground(Color.black);
      setLayout(new GridLayout(segmentText.length,1));
//    JLabel titleLB = new JLabel(title, SwingConstants.CENTER);
//    titleLB.setBackground(Color.black);
//    titleLB.setForeground(Color.cyan.darker() );
//    add(titleLB);
      labels = new JLabel[segmentText.length];
      for (int i=0; i<segmentText.length; i++ ) {
        labels[i] = new JLabel(segmentText[i], SwingConstants.LEFT);
        labels[i].setBackground(Color.black);
        labels[i].setForeground(segmentColors[i]);
        add( labels[i] );
      }

      data.addPropertyChangeListener(this);
      calcValues();
    }

   public void reset() {
     calcValues();
   }

	/**
    * This is called whenever the timer pops.
	 */
    public void propertyChange(PropertyChangeEvent e) {
      calcValues();
    }

    protected void calcValues() {
      int numValues = data.getNumValues();
      double[] values = data.getLatestDataValues();
      boolean activity = false;

      if (numValues > 0) {
        activity = data.isLatestValueNonZero();                // Anything nonzero is activity
      };

      Object[] parms = new Object[1];
      for (int i=0; i<segmentText.length; i++ ) {
        String txt = noActivityValue;
        if (activity) {
          txt = decimalFormat.format( values[i] );
        };
        parms[0] = txt;
        String msgText = MessageFormat.format(segmentText[i], parms);
        labels[i].setText(msgText);
      }

    }


}