import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;


/**
 * This paints the background colors on the list of queues.
 *
 * @author tjacopi
 *
 */
public class ListRenderer extends DefaultListCellRenderer {

  protected Color darkerBkColor = null;

   public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
     Component c = super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
     if (darkerBkColor == null) {
       Color defaultBkColor = c.getBackground();
       int newRed = makeNewColorValue( defaultBkColor.getRed(), 21);
       int newBlue = makeNewColorValue( defaultBkColor.getBlue(), 21);
       int newGreen = makeNewColorValue( defaultBkColor.getGreen(), 21);
       darkerBkColor = new Color( newRed, newGreen, newBlue);
//     darkerBkColor = new Color(234, 234, 234);
     };

     if (index%2 == 1 && !isSelected ) {
       c.setBackground(darkerBkColor);
     }

     return c;
   }

   private int makeNewColorValue(int originalValue, int distance) {
     int returnValue = 0;
     if (originalValue > distance) {
       returnValue = originalValue - distance;
     } else {
       returnValue = originalValue + distance;
     }
     return returnValue;
   }

}