import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.util.*;
import java.sql.*;
import java.beans.*;
import java.text.*;

/**
 * This is the panel that flips different status messages.
 *
 * @author tjacopi
 *
 */
public class QStatusPanel extends JPanel {
    public   static final String NoMsg = "NoMsg";
    public   static final String NoActivityMsg = "NoActivityMsg";
    public   static final String NoDataMsg = "NoDataMsg";

    protected CardLayout          labelPanelLayout = null;
    protected String              noDataMsg = null;

    public QStatusPanel() {
      this(null);
    }

    public QStatusPanel(String noDataMsg) {
      this.noDataMsg = noDataMsg;

      // We need to use a panel with a CardLayout so the layout manager will ensure
      // there is enough space for the label.  If we just set the label to not visible, then
      // if the layout manager does the panel, it will leave no space for the label.
      //labelPanel = new JPanel();
      setBackground(Color.black);
      labelPanelLayout = new CardLayout();
      setLayout(labelPanelLayout);

      JPanel p = new JPanel();
      p.setBackground(Color.black);
      p.setLayout( new FlowLayout(FlowLayout.RIGHT,2,0) );
      JLabel noActivityLB = new JLabel("No Activity", SwingConstants.RIGHT);
      Font boldFont = noActivityLB.getFont().deriveFont(Font.BOLD);
      noActivityLB.setFont(boldFont);
      noActivityLB.setBackground(Color.black);
      noActivityLB.setForeground(Color.yellow);
      Border lineBorder = new LineBorder(Color.yellow,1);
      Border emptyBorder = new EmptyBorder(0,2,0,2);
      noActivityLB.setBorder(new CompoundBorder(lineBorder, emptyBorder) );
      p.add(noActivityLB);
      add(p, NoActivityMsg);

      if (noDataMsg != null) {
        p = new JPanel();
        p.setBackground(Color.black);
        p.setLayout( new FlowLayout(FlowLayout.RIGHT,2,0) );
        JLabel noDataLB = new JLabel(noDataMsg, SwingConstants.RIGHT);
        noDataLB.setFont(boldFont);
        noDataLB.setBackground(Color.black);
        noDataLB.setForeground(Color.yellow);
        noDataLB.setBorder(new CompoundBorder(lineBorder, emptyBorder) );
        p.add(noDataLB);
        add(p, NoDataMsg);
      };

      JPanel blankPanel2 = new JPanel();                  // Just use an empty panel for the card.
      blankPanel2.setBackground(Color.black);
      add(blankPanel2, NoMsg);

      labelPanelLayout.show(this, NoMsg);
    }

   public String  getNoDataMsg() {
     return noDataMsg;
   }

   public void show(String panelId)  {
     labelPanelLayout.show(this, panelId);
   }


}