import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.util.*;

public class QueueSelectionDialog extends JDialog implements ActionListener, ListSelectionListener {

    protected JButton okButton;
    protected JButton cancelButton;
    protected boolean okPressed = false;
    protected JList   listBox = null;

    public QueueSelectionDialog(JFrame parent, String title, boolean modal, Vector possibleQueues) {
      super(parent, title, modal);
      getContentPane().setLayout( new BorderLayout() );
	   JLabel instructionLB = new JLabel("Select one or more queues to monitor");
      instructionLB.setBorder( new EmptyBorder(5,5,5,5) );
	   getContentPane().add( instructionLB , "North");

      listBox = new JList(possibleQueues);
      listBox.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION );
      listBox.addListSelectionListener(this);
      listBox.setCellRenderer( new ListRenderer() );
      JScrollPane sp = new JScrollPane(listBox);
	   getContentPane().add(sp, "Center");


      JPanel p = new JPanel();
      FlowLayout fl = new FlowLayout(FlowLayout.RIGHT);
	   okButton = new JButton("Ok");
	   cancelButton =  new JButton("Cancel");
      okButton.addActionListener( this );
      cancelButton.addActionListener( this );

      p.add(okButton);
      p.add(cancelButton);
      getRootPane().setDefaultButton( okButton );
      okButton.setEnabled(false);

	   getContentPane().add("South", p);
    }

    public void actionPerformed(final ActionEvent e) {
      okPressed = (e.getSource() == okButton);
      QueueSelectionDialog.this.dispose();
    }

    public boolean wasOkPressed() {
      return okPressed;
    }

    public Object[] getSelectedQueues() {
      return listBox.getSelectedValues();
    }

    public void valueChanged(ListSelectionEvent e) {
      int index = listBox.getSelectedIndex();
      okButton.setEnabled( index >=0 );
    }

}