//**************************************Copyright 1997 IBM Corporation*
//
// Java Programming
// Exercise 4 (Client User Interface) Solution
// Change History:
//   04/08/97 BDW Updated to V1.1
//
//*********************************************************************

import java.awt.*;
import java.awt.event.*;
import java.sql.*;
import java.util.*;

//  The main DB2 Command Processor applet.  Contains a command
//  input area and a message output area!

public class loadQApply {

  protected static String[] queues = { "B2R", "B2R_2", "B2R_3"};

  protected static int counter = 0;
  protected static Random random = new Random( System.currentTimeMillis() );

   public static void main(String s[]) {
      try {
         // register the driver with DriverManager
         // The newInstance() call is needed for the sample to work with
         // JDK 1.1.1 on OS/2, where the Class.forName() method does not
         // run the static initializer. For other JDKs, the newInstance
         // call can be omitted.
         Class.forName("COM.ibm.db2.jdbc.app.DB2Driver");
         System.out.println("Connecting to db " + s[0] );
         //                  MONITOR_TIME, RECVQ, END2END_LATENCY, QLATENCY, APPLY_LATENCY,
         String sql = "INSERT INTO ASN.IBMQREP_APPLYMON VALUES(?, ?, ?,0,0,?, ?, ?, 0,?,0,0,0,0,?,0,0,0,0,0,?,0,0,0,0,0,NULL)";
         Connection con = connect("DB2", s[0], "tjacopi", "wof12wof");
         while  (counter<10000)  {
           for (int i=0; i<3; i++) {
             int  capValue =  random.nextInt(500  );
             int  qValue     =  random.nextInt( 500  );
             int  applyValue     =  random.nextInt(  500 );
             int  rowCount       =  random.nextInt( 500  );
             int  notAppliedRows =  random.nextInt( 5 ) - 3;       // Only a 4 works....20% chance
             if (notAppliedRows <0) {
               notAppliedRows = 0;
             }
             int  totalValue =  capValue + qValue + applyValue;
             Timestamp t = new Timestamp( System.currentTimeMillis() );

             try {
               PreparedStatement stmt = con.prepareStatement(sql);
               stmt.setTimestamp(1, t);
               stmt.setString(2, queues[i]);
               stmt.setTimestamp(3, t);
               stmt.setInt(4, totalValue);
               stmt.setInt(5, qValue);
               stmt.setInt(6, applyValue);
               stmt.setInt(7, rowCount);
               stmt.setInt(8, notAppliedRows);
               stmt.setTimestamp(9, t);
               int rowsUpdated = stmt.executeUpdate();

               System.out.println("Row inserted for queue " + queues[i] + " at " + t );
               stmt.close();
             } catch( Exception e ) {
               e.printStackTrace();
             }
           }

           Thread.currentThread().sleep(5000);
//         run(con, "INSERT INTO TOM2 VALUES(?, 'DEF' ) ");
//         run(con, "INSERT INTO TOM3 VALUES(?, 'GHI' ) ");
           counter++;
         }
         close(con);
       } catch (Exception e) {
         e.printStackTrace();
       }
   }

   public static Connection connect(String db2Instance, String db2Database, String userid, String password) {
     Connection con = null;
      try {
        // URL is jdbc:db2:dbname  -->  jdbc:<instance>:<dbname>
          String url = "jdbc:" + db2Instance + ":" + db2Database;
 //     String url = "jdbc:" + "uiiserver1:50000:"+db2Instance + ":" + db2Database;
        System.out.println("URL = " + url + "<<" );
        con = DriverManager.getConnection(url,userid,password);
      } catch( Exception e ) {
         e.printStackTrace();
      }
      return con;
   }

   public static void close(Connection con) {
     try {
       // Close DB2 connection
       System.out.println("Closing DB2 connection");
       if (con != null) con.close();
     } catch( Exception e ) {
        e.printStackTrace();
     }
   }


}